package biz.hammurapi.dataflow;


public class ChainingMixer extends AbstractMixer {

	private String name;
	private JoinPredicate predicate;

	public ChainingMixer(String name, JoinPredicate predicate) {
		this.name = name;
		this.predicate = predicate;
	}

	protected void join(InputEntry[] inputs, String activatorName, DataSink sink) {
		if (predicate.toBeJoined(inputs, activatorName)) {
			sink.addData(chainInputs(inputs));
		}
	}

	public String getName() {
		return name;
	}

}
