package biz.hammurapi.dataflow;

/**
 * Data sinks consume data.
 * @author Pavel
 */
public interface DataSink {

	// Name?
	
	/**
	 * @return true if this sink controls multiplexing to "sibling" sinks, 
	 * i.e. if addData() can return true. 
	 */
	boolean controlsMultiplexing();
	
	/**
	 * @return Information about data items expected/required by the sink.
	 */
	DataItemInfo[] getDataInfo();

	/**
	 * Adds data to the sink.
	 * @param data
	 * @return true if data was "consumed" and shall be removed from further processing.
	 * If this sink is attached to a multiplexor, then the multiplexor shall not
	 * continue adding given data to "sibling" sinks. 
	 */
	boolean addData(Data data);
}
