package biz.hammurapi.dataflow;


public class MountingMixer extends AbstractMixer {

	private JoinPredicate predicate;
	private String name;
	private String separator;

	public MountingMixer(String name, JoinPredicate predicate, String separator) {
		this.predicate = predicate;
		this.name = name;
		this.separator = separator;
	}

	protected void join(InputEntry[] inputs, String activatorName, DataSink sink) {
		if (predicate.toBeJoined(inputs, activatorName)) {
			sink.addData(mountInputs(inputs, separator));
		}
	}

	public String getName() {
		return name;
	}

}
