package biz.hammurapi.rules;

import java.util.Iterator;

/**
 * Source of facts of particular type(s). Backward reasoning is built on
 * pulling facts of needed type from fact sources.
 * @author Pavel
 *
 */
public interface FactSource {

	/**
	 * @return Fact types provided by this source.
	 */
	Class[] getFactTypes();
	
	/**
	 * Retrieves facts.
	 * @param factType
	 * @return Iterator over facts of requested type.
	 */
	Iterator getFacts(Class factType);
}
