/*
 * hammurapi-rules @mesopotamia.version@
 * Hammurapi rules engine. 
 * Copyright (C) 2005  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.rules;

/**
 * Negates the object passed to the constructor. Uses == to compare identity.
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public class IdentityNegator implements Negator {

	private String msg;
	private Object obj;

	/**
	 * @param obj Object to be negated.
	 */
	public IdentityNegator(Object obj) {
		super();
		this.obj=obj;
	}
	
	/**
	 * @param obj Object to be negated.
	 * @param msg Message why the object was negated.
	 */
	public IdentityNegator(Object obj, String msg) {
		this(obj);
		this.msg=msg;
	}

	public boolean negates(Object obj) {
		return this.obj == obj;
	}

	/**
	 * @return Message why object was negated.
	 */
	public String getMessage() {
		return msg;
	}
}
