/*
 * hammurapi-rules @mesopotamia.version@
 * Hammurapi rules engine. 
 * Copyright (C) 2005  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.rules;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

import biz.hammurapi.config.DomConfigurableContainer;
import biz.hammurapi.config.RuntimeConfigurationException;
import biz.hammurapi.xml.dom.DOMUtils;


/**
 * Base class for containers of rules.
 * Implements getComponentName() method which returns value of <code>&lt;rule&gt/&lt;name&gt;</code> element.
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public abstract class RulesContainerBase extends DomConfigurableContainer implements KnowledgeBase {
	
	public RulesContainerBase() {
		super();
	}
	
	protected String getComponentName(Node node) {
		try {
			return DOMUtils.getSingleNonBlankElementText((Element) node, "name");
		} catch (Exception e) {
			throw new RuntimeConfigurationException("Cannot read rule name: "+e, e);
		}
	}
}
