package biz.hammurapi.rules.jsr94;

import javax.rules.ObjectFilter;

import biz.hammurapi.rules.CollectionManager;
import biz.hammurapi.rules.HandleManager;
import biz.hammurapi.rules.KnowledgeBase;
import biz.hammurapi.rules.KnowledgeCompactor;

/**
 * Container which holds objects required for rule session functionality.
 * @author Pavel
 *
 */
public interface RuleSessionContainer {

	/**
	 * @return Handle manager. Mandatory.
	 */
	HandleManager getHandleManager();

	/**
	 * @return Object filter. Optional.
	 */
	ObjectFilter getObjectFilter();

	/**
	 * @return Collection manager. Mandatory.
	 */
	CollectionManager getCollectionManager();

	/**
	 * @return Rules.
	 */
	KnowledgeBase getRules();

	/**
	 * @return Knowledge compactor. Optional.
	 */
	KnowledgeCompactor getKnowledgeCompactor();

	/**
	 * @return Rule set name.
	 */
	String getName();

	/**
	 * @return Rule set description.
	 */
	String getDescription();

}
