package biz.hammurapi.rules.jsr94;

import javax.rules.ObjectFilter;

import biz.hammurapi.config.Component;
import biz.hammurapi.config.ConfigurationException;
import biz.hammurapi.config.Context;
import biz.hammurapi.rules.CollectionManager;
import biz.hammurapi.rules.Constants;
import biz.hammurapi.rules.HandleManager;
import biz.hammurapi.rules.KnowledgeBase;
import biz.hammurapi.rules.KnowledgeCompactor;

class RuleSessionContainerContextWrapper implements RuleSessionContainer, Constants, Component {

	private Context master;

	public RuleSessionContainerContextWrapper(Context master) {
		this.master=master;
	}
	
	public CollectionManager getCollectionManager() {
		return (CollectionManager) master.get("/"+COLLECTION_MANAGER);
	}

	public String getDescription() {
		return (String) master.get("/"+DESCRIPTION);
	}

	public HandleManager getHandleManager() {
		return (HandleManager) master.get("/"+HANDLE_MANAGER);
	}

	public KnowledgeCompactor getKnowledgeCompactor() {
		return (KnowledgeCompactor) master.get("/"+KNOWLEDGE_COMPACTOR);
	}

	public String getName() {
		return (String) master.get("/"+NAME);
	}

	public ObjectFilter getObjectFilter() {
		return (ObjectFilter) master.get("/"+OBJECT_FILTER);
	}

	public KnowledgeBase getRules() {
		return (KnowledgeBase) master.get("/"+RULES);
	}

	public void setOwner(Object owner) {
		if (master instanceof Component) {
			((Component) master).setOwner(owner);
		}
	}

	public void start() throws ConfigurationException {
		if (master instanceof Component) {
			((Component) master).start();
		}
	}

	public void stop() throws ConfigurationException {
		if (master instanceof Component) {
			((Component) master).stop();
		}
	}

}
