package biz.hammurapi.rules.jsr94.admin;

import java.io.IOException;
import java.io.InputStream;
import java.io.Reader;
import java.util.HashMap;
import java.util.Map;

import javax.rules.admin.RuleExecutionSet;
import javax.rules.admin.RuleExecutionSetCreateException;

import org.w3c.dom.Element;

import biz.hammurapi.xml.dom.DOMUtils;


/**
 * Local Rule Execution Set Provider
 * @author Pavel Vlasov
 * @revision $Revision$
 */
class LocalRuleExecutionSetProvider implements	javax.rules.admin.LocalRuleExecutionSetProvider {
	
	private Map properties=new HashMap();

	/**
	 * Constructs provider.
	 * @param properties
	 */
	public LocalRuleExecutionSetProvider(Map properties) {
		if (properties!=null) {
			this.properties.putAll(properties);
		}
	}

	/**
	 * Reads XML definition from input stream.
	 */
	public RuleExecutionSet createRuleExecutionSet(InputStream in, Map properties) throws RuleExecutionSetCreateException, IOException {
		try {
			return new biz.hammurapi.rules.jsr94.admin.RuleExecutionSet(DOMUtils.parse(in).getDocumentElement(), properties);
		} catch (Exception e) {
			throw new RuleExecutionSetCreateException("Could not instantiate rules: "+e, e);
		}
	}

	/**
	 * Reads XML definition from Reader.
	 */
	public RuleExecutionSet createRuleExecutionSet(Reader in, Map properties) throws RuleExecutionSetCreateException, IOException {
		try {
			return new biz.hammurapi.rules.jsr94.admin.RuleExecutionSet(DOMUtils.parse(in).getDocumentElement(), properties);
		} catch (Exception e) {
			throw new RuleExecutionSetCreateException("Could not instantiate rules: "+e, e);
		}
	}

	/**
	 * Directly uses XML definition (the first parameter).
	 */
	public RuleExecutionSet createRuleExecutionSet(Object holder, Map properties) throws RuleExecutionSetCreateException {
		try {
			return new biz.hammurapi.rules.jsr94.admin.RuleExecutionSet((Element) holder, properties);
		} catch (Exception e) {
			throw new RuleExecutionSetCreateException("Could not instantiate rules: "+e, e);
		}
	}

}
